﻿using System;
using System.Text;
using System.Runtime.InteropServices;

namespace PCIELM4_MC
{

    //--------------------------------------------------------------------------
    //----------------- PCIELM4_MC DLL Function return values ------------------
    //--------------------------------------------------------------------------

    public enum MC_RETURN : int
    {       
        SUCCESS                      =(0),
        ERROR                        =(1),
        ERR_CARD_NOT_FOUND           =(2),
        ERR_INVALID_SLOT_NO          =(3),
        ERR_INVALID_PARA             =(4),
        ERR_INVALID_DRIVING_SPEED    =(5),
        ERR_INVALID_START_SPEED      =(6),
        ERR_INVALID_END_SPEED        =(7),
        ERR_INVALID_MPG_SPEED        =(8),
        ERR_INVALID_MOVE_DIRECTION   =(9),
        ERR_AXES_NOT_MATCH           =(10),
        
        
        ERR_GROUP_INVALID_DIMENSION        =(11),
        ERR_INVALID_GROUP_AXES             =(12),
        ERR_GROUP_NOT_CONFIGURED           =(13),
        ERR_GROUP_OUT_OF_RANGE             =(14),       //invalid Group input parameter
        ERR_INCORRECT_GROUP_ASSIGNED       =(15),
        ERR_GROUP_SAME_AXIS                =(16),
        ERR_GROUP_RELEASE_REQUIRED         =(17),

        ERR_MOTION_NOT_FINISHED            =(18),
        ERR_CARD_NOT_REGISTERED            =(19),
        ERR_INVALID_AXIS                   =(20),
        ERR_AXIS_ERROR                     =(21),              //motion stop due to an axis error (e.g. hardware limit, alarm),. Call GetAxisError() to determine the cause of the error
        ERR_CMD_NO_CLOSED_LOOP_SUPPORT     =(22),
        ERR_INTERPOL_NOT_CONFIGURED        =(23),
        ERR_INVALID_HELICAL_MODE           =(24),
        ERR_INVALID_FRNET_SPEED_SETTING    =(25),
        ERR_INVALID_FRNET_SA_GROUP_ADDR    =(26),
        ERR_INVALID_FRNET_RA_GROUP_ADDR    =(27),
        ERR_INVALID_MPG_GAIN               =(28),
        ERR_MPG_NOT_CONFIGURED             =(29),
        ERR_MOTION_IS_COMPLETED            =(30),
        	
        ERR_CMD_NOT_FOR_CONTI_INTERPOL     =(31),
        ERR_MODE_NOT_FOR_CONTI_INTERPOL    =(32),
        ERR_DPRAM_RTC_BLOCKS_AVAILABLE     =(33),
        ERR_DPRAM_RTC_BUFFER_FULL          =(34),   // All 24 RTC DPRAM buffer are filled with commands and still has to be processed
        EMG_ACVTIVATED                     =(35),	  //emergency has been activated

        ERR_CONFLICT_CONTI_INTERP_CONFIG   =(36),
        ERR_CONTI_INTERP_INVALID_CONFIG    =(37),
        ERR_CONTI_INTERP_INTERRUPTED       =(38),
        ERR_CONTI_INTERP_INVALID_START     =(39),
        ERR_CONTI_INTERP_FIFO_EMPTY        =(40),
        ERR_NOT_IN_CONTI_INTERP_MODE       =(41),
        ERR_CONTI_INTERP_START             =(42),
        ERR_INVALID_RING_COUNTER           =(43),
        ERR_ISR_IS_USED_FOR_CMP_TRIG       =(44),

        ERR_RTC_WAIT_ABORTED               =(45),
        ERR_RTC_TIMEOUT                    =(46),
        ERR_DSP_RESET                      =(47),
        ERR_DDA_IS_BUSY                    =(48),
         ERR_EXCEED_MAX_POSTION             =(49),
         ERR_NOT_SUPPORTED_BY_VRING_MODE    =(50),
         ERR_DLL_DO_NOT_SUPPORT_MULTI_APP   =(51),
         ERR_DRIVER_NOT_OPEN                =(52),
         ERR_NO_BOARD                       =(53),
         ERR_API_NOT_SUPPORTED              =(54),

         ERR_RESERVED_SPACE                 =(70),
        //Buffer APIs return:
        ERR_BUFFER_UNSUPPORTED_TYPE        =(71),
        ERR_BUFFER_INVALID_DATA            =(72),
        ERR_BUFFER_INVALID_CONTI_SIZE      =(73),
        ERR_BUFFER_INVALID_CONTI_FINISH    =(74),
        ERR_BUFFER_START                   =(75),
        ERR_BUFFER_INVALID_LOOP            =(76),
        ERR_BUFFER_INVALID_RESTART         =(77),
            

	        //DSP return code:
        ERR_DSP_SYSTEM_ERROR             =(-32767),
        ERR_DSP_NOT_IMPLEMENT            =(-32765),
        ERR_DSP_MOTIONPATH_FULL          =(-1001),
        ERR_DSP_REMAIN_STILL             =(-1002),
        ERR_DSP_DIMENSION_OUT_RANGE      =(-1003),
        ERR_DSP_SPEED_VALUE              =(-1004),
        ERR_DSP_SMALLSHAPE_ERROR         =(-1005),
        ERR_DSP_SAWSHAPE_ERROR           =(-1006),
        ERR_DSP_AXIS_INUSE               =(-1007),
        ERR_DSP_NORMALVECTOR             =(-1008),
        ERR_DSP_CIRCLE_RADIUS            =(-1009),
         ERR_DSP_MECH_PARA_VALUE          =(-1011),

        ERR_DSP_MOTIONPATH_ALREADY_FREE  =(-1100),
        ERR_DSP_EXCEED_SPEED_LIMIT       =(-1201),
         ERR_DSP_EXCEED_VRING_LIMIT       =(-1202),
         ERR_DSP_EXCEED_MAX_POSTION       =(-1203),

        ERR_DSP_NO_COMMAND               =(-2001),
        ERR_DSP_CRC_ERROR                =(-2002),
        ERR_DSP_UNKNOWN_COMMAND          =(-2003),
        ERR_DSP_MULTIBLOCK_CMD           =(-2004),
        ERR_DSP_ACC_TYPE                 =(-2005),
        ERR_DSP_DEC_TYPE                 =(-2006),
        ERR_DSP_CMD_NOT_ALLOWED          =(-2007),

        ERR_DSP_INHIBIT_BY_EMG           =(-2011),
        ERR_DSP_INHIBIT_BY_MPG_EMG       =(-2012),
        ERR_DSP_INHIBIT_BY_PEL           =(-2013),
        ERR_DSP_INHIBIT_BY_MEL           =(-2014),
        ERR_DSP_INHIBIT_BY_ALM           =(-2015),
        ERR_DSP_INHIBIT_BY_RDY           =(-2016),

        ERR_DSP_GROUP_OUT_RANGE          =(-2101),
        ERR_DSP_GROUP_ALREADY_FREE       =(-2102),
        ERR_DSP_GROUP_ASSIGNED           =(-2103),
        ERR_DSP_GROUP_INUSE              =(-2104),
        ERR_DSP_GROUP_NOT_INUSE          =(-2105),
        ERR_DSP_AXIS_ASSIGNED            =(-2106),

        ERR_DSP_CONTROL_MODE             =(-2201),

        //Buffer APIs return:
        ERR_DSP_BUFFER_FULL              =(-2301),
        ERR_DSP_BUFFER_INFO              =(-2302),
        ERR_DSP_BUFFER_TYPE              =(-2303),
        ERR_DSP_BUFFER_SIZE              =(-2304),
        ERR_DSP_BUFFER_INUSE             =(-2305),
        ERR_DSP_BUFFER_NOT_READY         =(-2306),

        ERR_DSP_STOP_BY_P_CHANGE         =(-2401),
        ERR_DSP_CLEAR_STOP               =(-2402),

        ERR_DSP_STOP_BY_GINP             =(-2410),
        ERR_DSP_STOP_BY_AXIS_IO          =(-2430),

        ERR_DSP_NO_AVAILABLE_MACRO       =(-2501),
        ERR_DSP_MACRO_INUSE              =(-2502),
        ERR_DSP_MACRO_EMPTY              =(-2503),

        ERR_DSP_HOMING_IN_PROGRESS       =(-2601),

        ERR_DSP_OUTPUT_SATURATION        =(-3001),
        ERR_DSP_ERR_MSG_BUF_EMPTY        =(-3011),
        ERR_DSP_ERR_MSG_BUF_OVERFLOW     =(-3012),
         ERR_DSP_ERR_TEST_FRAM            =(-4001),
         ERR_DSP_ERR_TEST_DPRAM           =(-4002)
    };
    
    class CLM4MC
    {
        //*** initial system
        [DllImport("PCIELM4_MC.dll", EntryPoint = "pcielm4_open_driver")]
        public static extern MC_RETURN pcielm4_open_driver();

        [DllImport("PCIELM4_MC.dll", EntryPoint = "pcielm4_close_driver")]
        public static extern MC_RETURN pcielm4_close_driver();

        [DllImport("PCIELM4_MC.dll", EntryPoint = "pcielm4_registration")]
        public static extern MC_RETURN pcielm4_registration(ushort BoardNo);

        [DllImport("PCIELM4_MC.dll", EntryPoint = "pcielm4_check_card_in_slot")]
        public static extern MC_RETURN pcielm4_check_card_in_slot(ushort BoardNo);

        [DllImport("PCIELM4_MC.dll", EntryPoint = "pcielm4_get_card_version")]
        public static extern MC_RETURN pcielm4_get_card_version(ushort BoardNo, ref ushort PCBVersion, ref ushort PLDVersion);

        [DllImport("PCIELM4_MC.dll", EntryPoint = "pcielm4_get_fpga_version")]
        public static extern MC_RETURN pcielm4_get_fpga_version(ushort BoardNo, ref ushort FpgaVers);

        [DllImport("PCIELM4_MC.dll", EntryPoint = "pcielm4_get_dsp_firmware_version")]
        public static extern MC_RETURN pcielm4_get_dsp_firmware_version(ushort BoardNo, ref ushort DspFirmwareVers);

        [DllImport("PCIELM4_MC.dll", EntryPoint = "pcielm4_get_dll_version")]
        public static extern MC_RETURN pcielm4_get_dll_version(ref ushort DllVers);

        //----------------------------------------------------------------------------------------------------------
        //Motion Status
        //----------------------------------------------------------------------------------------------------------

        [DllImport("PCIELM4_MC.dll", EntryPoint = "pcielm4_get_motion_done")]
        public static extern MC_RETURN pcielm4_get_motion_done(ushort BoardNo, byte SingleAxis, ref byte Done,  ref ushort StopStatus);
        
        [DllImport("PCIELM4_MC.dll", EntryPoint = "pcielm4_get_cmdcounter")]
        public static extern MC_RETURN pcielm4_get_cmdcounter(ushort BoardNo, byte SingleAxis, ref int LogicPosCount);
 
        [DllImport("PCIELM4_MC.dll", EntryPoint = "pcielm4_get_enccounter")]
        public static extern MC_RETURN pcielm4_get_enccounter(ushort BoardNo, byte SingleAxis, ref int EncoderPosCount);

        [DllImport("PCIELM4_MC.dll", EntryPoint = "pcielm4_get_position")]
        public static extern MC_RETURN pcielm4_get_position(ushort BoardNo, byte SingleAxis, ref int Pos);
       
        [DllImport("PCIELM4_MC.dll", EntryPoint = "pcielm4_get_max_speed")]
        public static extern MC_RETURN pcielm4_get_max_speed(ushort BoardNo, byte SingleAxis, ref uint MaxSpeed);
        
        [DllImport("PCIELM4_MC.dll", EntryPoint = "pcielm4_get_speed")]
        public static extern MC_RETURN pcielm4_get_speed(ushort BoardNo, byte SingleAxis, ref int Speed);
        
        [DllImport("PCIELM4_MC.dll", EntryPoint = "pcielm4_get_acc")]
        public static extern MC_RETURN pcielm4_get_acc(ushort BoardNo, byte SingleAxis, ref int Acc);


        //==================================================================
        //------------ RTC Commands
        //==================================================================
        [DllImport("PCIELM4_MC.dll", EntryPoint = "pcielm4_set_pls_cfg")]
        public static extern MC_RETURN pcielm4_set_pls_cfg(ushort BoardNo, byte SingleAxis, ushort PulseMode,  byte PulseLogic, byte DirectionLogic);
       
        [DllImport("PCIELM4_MC.dll", EntryPoint = "pcielm4_set_enc_cfg")]
        public static extern MC_RETURN pcielm4_set_enc_cfg(ushort BoardNo, byte SingleAxis, ushort EncoderMode);

        [DllImport("PCIELM4_MC.dll", EntryPoint = "pcielm4_set_limit")]
        public static extern MC_RETURN pcielm4_set_limit(ushort BoardNo, byte SingleAxis, byte LimitLogic, byte StopMode);
        
        [DllImport("PCIELM4_MC.dll", EntryPoint = "pcielm4_set_softlimit")]
        public static extern MC_RETURN pcielm4_set_softlimit(ushort BoardNo, byte SingleAxis, byte StopMode, byte RefSource, int LimitPositive, int LimitNegative);

        [DllImport("PCIELM4_MC.dll", EntryPoint = "pcielm4_set_softlimit_disable")]
        public static extern MC_RETURN pcielm4_set_softlimit_disable(ushort BoardNo, byte SingleAxis);
  
        [DllImport("PCIELM4_MC.dll", EntryPoint = "pcielm4_set_max_speed")]
        public static extern MC_RETURN pcielm4_set_max_speed(ushort BoardNo, byte SingleAxis, uint MaxSpeed);

        [DllImport("PCIELM4_MC.dll", EntryPoint = "pcielm4_set_home_cfg")]
        public static extern MC_RETURN pcielm4_set_home_cfg(ushort BoardNo, byte SingleAxis, byte HomeLogic, byte NHomeLogic, byte IndexLogic, byte HomeSteps, int Step4Offset);

        [DllImport("PCIELM4_MC.dll", EntryPoint = "pcielm4_home_start")]
        public static extern MC_RETURN pcielm4_home_start(ushort BoardNo, byte SingleAxis, uint StartSpeed, uint Acceleration, uint Deceleration, uint NHomeSearchSpeed, uint HomeSearchSpeed, byte HomingDirection);

        //------------------------
        //Motion DO Setting:
        //------------------------
        [DllImport("PCIELM4_MC.dll", EntryPoint = "pcielm4_set_axis_do")]
        public static extern MC_RETURN pcielm4_set_axis_do(ushort BoardNo, byte SingleAxis, byte DOChannel, byte OnOff);

        [DllImport("PCIELM4_MC.dll", EntryPoint = "pcielm4_set_servo_on")]
        public static extern MC_RETURN pcielm4_set_servo_on(ushort BoardNo, byte SingleAxis, byte ServoOnOff);

        [DllImport("PCIELM4_MC.dll", EntryPoint = "pcielm4_set_erc")]
        public static extern MC_RETURN pcielm4_set_erc(ushort BoardNo, byte SingleAxis, byte ErcOnOff);

        [DllImport("PCIELM4_MC.dll", EntryPoint = "pcielm4_set_alarm_reset")]
        public static extern MC_RETURN pcielm4_set_alarm_reset(ushort BoardNo, byte SingleAxis, byte AlmRstOnOff);

        //------------------------
        //Motion DI Setting:
        //------------------------
        [DllImport("PCIELM4_MC.dll", EntryPoint = "pcielm4_set_alarm")]
        public static extern MC_RETURN pcielm4_set_alarm(ushort BoardNo, byte SingleAxis, byte EnableDisable,  byte TrigLevel);

        [DllImport("PCIELM4_MC.dll", EntryPoint = "pcielm4_set_inp")]
        public static extern MC_RETURN pcielm4_set_inp(ushort BoardNo, byte SingleAxis, byte EnableDisable, byte INPLogic);

        [DllImport("PCIELM4_MC.dll", EntryPoint = "pcielm4_set_ready")]
        public static extern MC_RETURN pcielm4_set_ready(ushort BoardNo, byte SingleAxis, byte EnableDisable, byte RdyLogic);

        [DllImport("PCIELM4_MC.dll", EntryPoint = "pcielm4_set_axis_di_filter")]
        public static extern MC_RETURN pcielm4_set_axis_di_filter(ushort BoardNo, byte SingleAxis, byte bFilterEnable, ushort AxisDiChannel,	ushort DelayTime);


        //------------------------
        //Motion Setting:
        //------------------------
        [DllImport("PCIELM4_MC.dll", EntryPoint = "pcielm4_set_cmdcounter")]
        public static extern MC_RETURN pcielm4_set_cmdcounter(ushort BoardNo, byte SingleAxis, int LogicPos);

        [DllImport("PCIELM4_MC.dll", EntryPoint = "pcielm4_set_enccounter")]
        public static extern MC_RETURN pcielm4_set_enccounter(ushort BoardNo, byte SingleAxis, int EncPos);

        [DllImport("PCIELM4_MC.dll", EntryPoint = "pcielm4_set_position")]
        public static extern MC_RETURN pcielm4_set_position(ushort BoardNo, byte SingleAxis, int LogicPos);

        [DllImport("PCIELM4_MC.dll", EntryPoint = "pcielm4_set_vring_counter")]
        public static extern MC_RETURN pcielm4_set_vring_counter(ushort BoardNo, byte SingleAxis, uint RingValue);

        [DllImport("PCIELM4_MC.dll", EntryPoint = "pcielm4_get_vring_counter")]
        public static extern MC_RETURN pcielm4_get_vring_counter(ushort BoardNo, byte SingleAxis, ref uint RingValue);

        [DllImport("PCIELM4_MC.dll", EntryPoint = "pcielm4_disable_vring_counter")]
        public static extern MC_RETURN pcielm4_disable_vring_counter(ushort BoardNo, byte SingleAxis);




        [DllImport("PCIELM4_MC.dll", EntryPoint = "pcielm4_set_compare_trig_cfg")]
        public static extern MC_RETURN pcielm4_set_compare_trig_cfg(ushort BoardNo, byte SingleAxis, byte CmpTrigEnable, byte OutputLogic, ushort PulseWidth, byte MoveDirection, byte CmpIncEnable, ushort ConstPitch, int CmpData);
      
         [DllImport("PCIELM4_MC.dll", EntryPoint = "pcielm4_set_conti_interp_cfg")]
        public static extern MC_RETURN pcielm4_set_conti_interp_cfg(ushort BoardNo, byte CfgEnable, ushort GroupIndex0);
       
         [DllImport("PCIELM4_MC.dll", EntryPoint = "pcielm4_velocity_move")]
        public static extern MC_RETURN pcielm4_velocity_move(ushort BoardNo, byte SingleAxis, uint StartSpeed, uint DriveSpeed, uint Acceleration, byte Direction);
       
       
        //------------------------
        //Motion Commands:
        //------------------------
        
        //--------------------------------------------------------------------------------------------------------------------------------
        [DllImport("PCIELM4_MC.dll", EntryPoint = "pcielm4_const_move")]
        public static extern MC_RETURN pcielm4_const_move(ushort BoardNo, byte SingleAxis, uint DriveSpeed, int lFixedPulse);

        [DllImport("PCIELM4_MC.dll", EntryPoint = "pcielm4_abs_const_move")]
        public static extern MC_RETURN pcielm4_abs_const_move(ushort BoardNo, byte SingleAxis, uint DriveSpeed, int lFixedPulse);

        //--------------------------------------------------------------------------------------------------------------------------------
        [DllImport("PCIELM4_MC.dll", EntryPoint = "pcielm4_t_move")]
        public static extern MC_RETURN pcielm4_t_move(ushort BoardNo, byte SingleAxis, uint StartSpeed, uint DriveSpeed, uint EndSpeed, uint Acceleration, uint Deceleration, int FixedPulse);

        [DllImport("PCIELM4_MC.dll", EntryPoint = "pcielm4_abs_t_move")]
        public static extern MC_RETURN pcielm4_abs_t_move(ushort BoardNo, byte SingleAxis, uint StartSpeed, uint DriveSpeed, uint EndSpeed, uint Acceleration, uint Deceleration, int FixedPulse);

        //--------------------------------------------------------------------------------------------------------------------------------
        [DllImport("PCIELM4_MC.dll", EntryPoint = "pcielm4_s_move")]
        public static extern MC_RETURN pcielm4_s_move(ushort BoardNo, byte SingleAxis, uint StartSpeed, uint DriveSpeed, uint EndSpeed, uint Acceleration, uint Deceleration, int FixedPulse);

        [DllImport("PCIELM4_MC.dll", EntryPoint = "pcielm4_abs_s_move")]
        public static extern MC_RETURN pcielm4_abs_s_move(ushort BoardNo, byte SingleAxis, uint StartSpeed, uint DriveSpeed, uint EndSpeed, uint Acceleration, uint Deceleration, int FixedPulse);

        //--------------------------------------------------------------------------------------------------------------------------------
        [DllImport("PCIELM4_MC.dll", EntryPoint = "pcielm4_t_line2_move")]
        public static extern MC_RETURN pcielm4_t_line2_move(ushort BoardNo, byte MainAxis, byte SlaveAxis, uint StartSpeed, uint DriveSpeed, uint EndSpeed, uint Acceleration, uint Deceleration, int MainAxisRelDist, int SlaveAxisRelDist, ushort InterpMode);
      
        [DllImport("PCIELM4_MC.dll", EntryPoint = "pcielm4_abs_t_line2_move")]
        public static extern MC_RETURN pcielm4_abs_t_line2_move(ushort BoardNo, byte MainAxis, byte SlaveAxis, uint StartSpeed, uint DriveSpeed, uint EndSpeed, uint Acceleration, uint Deceleration, int MainAxisFinishPoint, int SlaveAxisFinishPoint, ushort InterpMode);

        //--------------------------------------------------------------------------------------------------------------------------------
        [DllImport("PCIELM4_MC.dll", EntryPoint = "pcielm4_s_line2_move")]
        public static extern MC_RETURN pcielm4_s_line2_move(ushort BoardNo, byte MainAxis, byte SlaveAxis, uint StartSpeed, uint DriveSpeed, uint EndSpeed, uint Acceleration, uint Deceleration, int MainAxisRelDist, int SlaveAxisRelDist, ushort InterpMode);

        [DllImport("PCIELM4_MC.dll", EntryPoint = "pcielm4_abs_s_line2_move")]
        public static extern MC_RETURN pcielm4_abs_s_line2_move(ushort BoardNo, byte MainAxis, byte SlaveAxis, uint StartSpeed, uint DriveSpeed, uint EndSpeed, uint Acceleration, uint Deceleration, int MainAxisFinishPoint, int SlaveAxisFinishPoint, ushort InterpMode);

        //--------------------------------------------------------------------------------------------------------------------------------
        [DllImport("PCIELM4_MC.dll", EntryPoint = "pcielm4_t_arc2_move")]
        public static extern MC_RETURN pcielm4_t_arc2_move(ushort BoardNo, byte MainAxis, byte SlaveAxis, uint StartSpeed, uint DriveSpeed, uint EndSpeed, uint Acceleration, uint Deceleration,  byte ArcDirection, int MainAxisCenterPoint, int SlaveAxisCenterPoint, int MainAxisFinishPoint, int SlaveAxisFinishPoint, ushort wInterpMode);
 
        [DllImport("PCIELM4_MC.dll", EntryPoint = "pcielm4_abs_t_arc2_move")]
        public static extern MC_RETURN pcielm4_abs_t_arc2_move(ushort BoardNo, byte MainAxis, byte SlaveAxis, uint StartSpeed, uint DriveSpeed, uint EndSpeed, uint Acceleration, uint Deceleration,  byte ArcDirection, int MainAxisCenterPoint, int SlaveAxisCenterPoint, int MainAxisFinishPoint, int SlaveAxisFinishPoint, ushort wInterpMode);
 
        //--------------------------------------------------------------------------------------------------------------------------------
        [DllImport("PCIELM4_MC.dll", EntryPoint = "pcielm4_lines_move")]
        public static extern MC_RETURN pcielm4_lines_move(ushort BoardNo, ushort Axes, ushort AccDecMode,			
	                                      uint StartSpeed, uint DriveSpeed, uint EndSpeed, uint Acceleration, uint Deceleration,		        
	                                      int[] RelativeDistance, ushort InterpMode);


        [DllImport("PCIELM4_MC.dll", EntryPoint = "pcielm4_abs_lines_move")]
        public static extern MC_RETURN pcielm4_abs_lines_move(ushort BoardNo, ushort Axes, ushort AccDecMode,			
	                                      uint StartSpeed, uint DriveSpeed, uint EndSpeed, uint Acceleration, uint Deceleration,		        
	                                      int[] AbsolutePosition, ushort InterpMode);
        //--------------------------------------------------------------------------------------------------------------------------------

        [DllImport("PCIELM4_MC.dll", EntryPoint = "pcielm4_drv_hold")]
        public static extern MC_RETURN pcielm4_drv_hold(ushort BoardNo, ushort BitMultiAxes );
        
        [DllImport("PCIELM4_MC.dll", EntryPoint = "pcielm4_drv_start")]
        public static extern MC_RETURN pcielm4_drv_start(ushort BoardNo, ushort BitMultiAxes );

        [DllImport("PCIELM4_MC.dll", EntryPoint = "pcielm4_stop_move")]
        public static extern MC_RETURN pcielm4_stop_move(ushort BoardNo, byte SingleAxis, byte StopMode );

        [DllImport("PCIELM4_MC.dll", EntryPoint = "pcielm4_reset")]
        public static extern MC_RETURN pcielm4_reset(ushort BoardNo);

        //--------------------------------------------------------------------------------------------------------------------------------

        [DllImport("PCIELM4_MC.dll", EntryPoint = "pcielm4_set_latch_cfg")]
        public static extern MC_RETURN pcielm4_set_latch_cfg(ushort BoardNo, byte SingleAxis, byte LatchEnable, byte LatchLogic);

        [DllImport("PCIELM4_MC.dll", EntryPoint = "pcielm4_get_latch")]
        public static extern MC_RETURN pcielm4_get_latch(ushort BoardNo, byte SingleAxis, ref int LatchData);

        [DllImport("PCIELM4_MC.dll", EntryPoint = "pcielm4_get_error_status")]
        public static extern MC_RETURN pcielm4_get_error_status(ushort BoardNo, byte SingleAxis, ref ushort ErrorStatus);

        [DllImport("PCIELM4_MC.dll", EntryPoint = "pcielm4_get_mdi_status")]
        public static extern MC_RETURN pcielm4_get_mdi_status(ushort BoardNo, byte SingleAxis, ref ushort DIStatus);

        [DllImport("PCIELM4_MC.dll", EntryPoint = "pcielm4_get_servo_on_status")]
        public static extern MC_RETURN pcielm4_get_servo_on_status(ushort BoardNo, byte SingleAxis, ref byte ServoOn);

        [DllImport("PCIELM4_MC.dll", EntryPoint = "pcielm4_get_servo_erc_status")]
        public static extern MC_RETURN pcielm4_get_servo_erc_status(ushort BoardNo, byte SingleAxis, ref byte ServoErc);

        [DllImport("PCIELM4_MC.dll", EntryPoint = "pcielm4_get_servo_almrst_status")]
        public static extern MC_RETURN pcielm4_get_servo_almrst_status(ushort BoardNo, byte SingleAxis, ref byte ServoAlarm);  
    
    }
}
